#include <stdio.h>
#include <stdlib.h>
#include <linux/major.h>

void main(int argc, char **argv)
{ /* Begin main */

	char commandString[100];
	int nonPCIports, requestedPCIports, portNumber, retVal;

	if (argc != 3)
	{
		printf("<Error> - Invalid format \n");
		printf("          buildPCI <number of non PCI ports> <number of PCI ports>\n");
		exit(-1);
	}	

	nonPCIports = atoi(argv[1]);
	requestedPCIports = atoi(argv[2]);
	for (portNumber = nonPCIports; portNumber < (nonPCIports + requestedPCIports); portNumber++)
	{ /* For each requested port do */

		sprintf(commandString,"mknod /dev/cud%d c %d %d",
		        portNumber, DIGICU_MAJOR, portNumber);

		retVal = system(commandString);
		if ((retVal == -1) || (retVal == 127))
		{
			printf("<Error> - first system call failed, retVal = 0x%x\n",retVal);
			exit(-1);
		}

		sprintf(commandString,"mknod /dev/ttyD%d c %d %d",
		        portNumber, DIGI_MAJOR, portNumber);

		retVal = system(commandString);
		if ((retVal == -1) || (retVal == 127))
		{
			printf("<Error> - second system call failed, retVal = 0x%x\n",retVal);
			exit(-1);
		}

		if (nonPCIports == 0) 
		{ /* Begin build control node */

		} /* End build control node */

	} /* End for each requested port do */

	sprintf(commandString,"mknod /dev/digiCtl c 35 0");

	retVal = system(commandString);
	if ((retVal == -1) || (retVal == 127))
	{
		printf("<Error> - third system call failed, retVal = 0x%x\n",retVal);
		exit(-1);
	}

	sprintf(commandString,"mknod /dev/digi_ctl c 35 0");

	retVal = system(commandString);
	if ((retVal == -1) || (retVal == 127))
	{
		printf("<Error> - fourth system call failed, retVal = 0x%x\n",retVal);
		exit(-1);
	}
	retVal = system("chmod a+wx /dev/digiCtl");
	if ((retVal == -1) || (retVal == 127))
	{
		printf("<Error> - first chmod system call failed, retVal = 0x%x\n",retVal);
		exit(-1);
	}

	retVal = system("chmod a+wx /dev/digi_ctl");
	if ((retVal == -1) || (retVal == 127))
	{
		printf("<Error> - first chmod system call failed, retVal = 0x%x\n",retVal);
		exit(-1);
	}

	retVal = system("chmod a+wx /dev/cud*");
	if ((retVal == -1) || (retVal == 127))
	{
		printf("<Error> - first chmod system call failed, retVal = 0x%x\n",retVal);
		exit(-1);
	}

	retVal = system("chmod a+wx /dev/ttyD*");
	if ((retVal == -1) || (retVal == 127))
	{
		printf("<Error> - second chmod system call failed, retVal = 0x%x\n",retVal);
		exit(-1);
	}

} /* End main */
